# TetrisGL
Just another tetris game with OpenGL graphics

## Overview
This project has developed for training purposes only.  
It has been written in C++ and uses OpenGL to render all graphics.  
Signed Distance Field Font technique was used for rendering all texts in the game.

## Installation
### Windows
1. Download the latest [release](https://github.com/BaZzz01010101/TetrisGL/releases/latest)
2. Unpack it to any folder you want
3. Run TetrisGL or TetrisGL64 executable
### Linux
1. Install packages libasound-dev, libglew-dev
2. Install or compile GLFW
3. Build
```
mkdir build
cd build
cmake ..
make -j 4
```
4. Run bin/TerisGL
You can change ALSA device by setting environment variable MMC_PLAY_DEVICE.
Also FPS can be displayed by setting environment variable FPS_COUNTER


## Third-party libraries used
+ [GLEW](http://glew.sourceforge.net/) - The OpenGL Extension Wrangler Library
+ [GLFW](http://www.glfw.org/) - Library for creating windows with OpenGL contexts and processing events
+ [GLM](http://glm.g-truc.net) - Mathematics library based on the OpenGL Shading Language (GLSL) specifications
+ [FMOD](http://www.fmod.org/) - FMOD Low Level Programmer API
+ [RapidJSON](http://rapidjson.org/) - A fast JSON parser/generator for C++ with both SAX/DOM style API
+ ~~[FreeType](http://www.freetype.org/) - Library to render fonts~~ *dependency removed*
+ [stb_image](https://github.com/nothings/stb) - Image loader/decoder

## Music credits
+ [Strawberry](http://www.newgrounds.com/audio/listen/572013) by `XayberOptix`

## Sound FX credits
+ [Button Confirm Spacey](http://www.freesound.org/people/GameAudio/sounds/220166/) by `GameAudio`
+ [Computer Beep SFX for Videogames](http://www.freesound.org/people/qubodup/sounds/140773/) by `qubodup`
+ [kick](http://www.freesound.org/people/mattybattyfenno/sounds/33645/) by `mattybattyfenno`
+ [Wipee1](http://www.freesound.org/people/kennysvoice/sounds/158401/) by `kennysvoice`
+ [scratch](http://www.freesound.org/people/TheGreenSwitchDilemma/sounds/17763/) by `TheGreenSwitchDilemma`
+ [Click_Standard_00](http://www.freesound.org/people/LittleRobotSoundFactory/sounds/288909/) by `LittleRobotSoundFactory`
+ [ Oneshot Bass 2](http://www.freesound.org/people/staticpony1/sounds/249587/) by `staticpony1`

\* all sounds was additionally processed

## License
This software released under [GNU GPL v3](http://www.gnu.org/licenses/gpl.html)

## Screenshots
[<img src="https://raw.githubusercontent.com/BaZzz01010101/TetrisGL/master/screenshots/Play1.jpg" width="50%" />](https://raw.githubusercontent.com/BaZzz01010101/TetrisGL/master/screenshots/Play1.jpg)
[<img src="https://raw.githubusercontent.com/BaZzz01010101/TetrisGL/master/screenshots/Play2.jpg" width="50%" />](https://raw.githubusercontent.com/BaZzz01010101/TetrisGL/master/screenshots/Play2.jpg)
[<img src="https://raw.githubusercontent.com/BaZzz01010101/TetrisGL/master/screenshots/MainMenu.jpg" width="50%" />](https://raw.githubusercontent.com/BaZzz01010101/TetrisGL/master/screenshots/MainMenu.jpg)
[<img src="https://raw.githubusercontent.com/BaZzz01010101/TetrisGL/master/screenshots/Settings.jpg" width="50%" />](https://raw.githubusercontent.com/BaZzz01010101/TetrisGL/master/screenshots/Settings.jpg)
[<img src="https://raw.githubusercontent.com/BaZzz01010101/TetrisGL/master/screenshots/Leaderboard.jpg" width="50%" />](https://raw.githubusercontent.com/BaZzz01010101/TetrisGL/master/screenshots/Leaderboard.jpg)
